
import Taro, { Component } from '@tarojs/taro'
import { View, Text, Picker } from '@tarojs/components'
import { AtList, AtListItem, } from 'taro-ui'

import './aliIndustryTypeInteraction.scss'
import loginExpired from '../../util/loginExpired';
import { getGlobalStorage } from '../../util/getSetStoage';


let maxDepth = 0
let initialDataArray = []
class AliIndustryTypeInteraction extends Component {

    config = {
        navigationBarTitleText: 'aliIndustryTypeInteraction'
    }
    constructor() {
        super(...arguments);

        this.state = {
            ///---行业分类 开始
            initailMultiArray: '',// 初始化底部数据
            multiIndex: [0, 0],
            interactionMultiArray: [],// 联动
            AliIsShowPicker: false,
            ///---行业分类 结束

        }

    }
    // 行业分类筛选列表GetIndustryTypeList
    getIndustryTypeList(url) {
        Taro.request({
            url: url,
            method: 'GET',
            dataType: 'json',
            header: {
                'Cookie': 'PFWSSS=' + getGlobalStorage('session_id'),
                'content-type': 'application/x-www-form-urlencoded',
                'X-Requested-With': 'XMLHttpRequest'
            }
        }).then(res => {
            console.log('res',res)
            if (res.data.err_code === 0) {

                let initailMultiArray = this.recursionInitialized(res.data.data)
                initailMultiArray[1].unshift({ name: '全部', id: '-1' })
                initailMultiArray[0] = [{ name: '--', id: '' }]
                // console.log('initailMultiArray', initailMultiArray)


                this.setState({
                    initailMultiArray: initailMultiArray.reverse(),                //initailMultiArray.reverse(),
                    interactionMultiArray: [{ name: '全部', id: '-1', children: [{ name: '--', id: '' }] }, ...this.recursionInteraction(res.data.data)],
                    multiIndex: this.recursionDepth(res.data.data),
                }, () => {
                    initialDataArray = []
                    console.log('state',this.state.interactionMultiArray)
                })

            } else if (res.data.err_code === 88888) {
                // loginExpired(res)
            } else {
                console.log('行业分类请求没有成功', res)
            }
        }
        )
            .catch(error => {
                console.log('行业分类请求错误', error)
            })
    }
    // 递归整理无限层联动数据
    recursionInteraction(data) {
        let arrayTem = []
        for (let items of data) {
            arrayTem.push({ name: items.class_name, id: items.class_id })
            if (items.child.length) {
                arrayTem[arrayTem.length - 1].children = [{ name: '--', id: '' }, ...this.recursionInteraction(items.child)]
            } else {
                arrayTem[arrayTem.length - 1].children = [{ name: '--', id: '' }]
            }
        }
        return arrayTem  // 返回联动数据
        //  return arrayTem
    }
    // 递归整理无限层初始数据
    recursionInitialized(data) {
        const arrayTem = []
        const childrenHolderArray = []
        if (data.length) {
            for (let item of data) {
                arrayTem.push({ name: item.class_name, id: item.class_id })
                if (data.indexOf(item) === 0) {
                    item.child.length ? childrenHolderArray.push(...item.child) : null
                }
            }
            this.recursionInitialized(childrenHolderArray)
        }
        arrayTem.length ? initialDataArray.push(arrayTem) : null // 数组为空则不添加
        return initialDataArray
    }
    // 递归整理无限层层次
    recursionDepth(data) {
        const arrayTem = []
        const childrenHolderArray = []
        if (data.length) {
            for (let item of data) {
                arrayTem.push({ name: item.class_name, id: item.class_id })
                item.child.length ? childrenHolderArray.push(...item.child) : null
            }
            this.recursionDepth(childrenHolderArray)
            maxDepth += 1
        }
        return new Array(maxDepth).fill(0)
    }
    bindMultiPickerCol(e) {
        // console.log('修改的列为', e.detail.column, '，值为', e.detail.value)

        const data = {
            multiArray: this.state.initailMultiArray,
            multiIndex: this.state.multiIndex
        }
        data.multiIndex[e.detail.column] = e.detail.value
        if (e.detail.column == 0) {
            for (let index in data.multiArray[0]) {
                const indexNumber = Number(index)
                if (indexNumber === data.multiIndex[0]) {
                    data.multiArray[1] = this.state.interactionMultiArray[indexNumber].children

                }
            }
        }
        this.setState({ multiIndex: data.multiIndex })

    }

    //--------------------开始-行业分类picker
    bindMultiPickerChange(e) {
        this.setState({
            multiIndex: e.detail.value,
        }, () => {
            this.passDataToParent()
        })

    }



    //--------------------结束-行业分类picker
    passDataToParent() {
        const parent = this.state.interactionMultiArray[this.state.multiIndex[0]]
        const child = this.state.interactionMultiArray[this.state.multiIndex[0]].children[this.state.multiIndex[1]]
        child.id ? this.props.onPassDataToChild(child) : this.props.onPassDataToChild(parent)
    }

    aliBindMultiPickerCol(e) {
        console.log('e', e)
        console.log('，值为', e.detail.value)

        this.setState({ multiIndex: e.detail.value })
    }

    aliCancelButton() {
        this.setState({
            AliIsShowPicker: false
        })
    }
    aliConfirmButton() {
        this.setState({
            AliIsShowPicker: false
        })
        let result = this.state.interactionMultiArray[this.state.multiIndex[0]].children[this.state.multiIndex[1]]

        this.passDataToParent(result)
    }
    invokeAliPicker() {
        this.setState({
            AliIsShowPicker: true
        })
    }


    componentDidMount() {
        this.getIndustryTypeList(this.props.url)
    }
    // 当然父组件有新的props的 会从新渲染组件
    componentWillReceiveProps(nextProps) {

    }
    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }

    render() {
        return (
            <View className='industry-interaction' >
                <View className='picker-wrapper' onClick={this.invokeAliPicker.bind(this)} >
                    <AtList  >
                        <AtListItem  hasBorder={false} title='行业分类' className='title' extraText={this.props.selectedValue.name} arrow='right' />
                    </AtList>
                </View>
                {this.state.AliIsShowPicker ? <View>
                    <View className='curtain' onClick={this.aliCancelButton.bind(this)} > </View>

                    <View class='ali-picker-container'>
                        <View className='button'>
                            <View className='cancel-button' onClick={this.aliCancelButton.bind(this)}>取消</View>
                            <View className='confirm-button ali-blue-color' onClick={this.aliConfirmButton.bind(this)}>确定</View>
                        </View>
                        <picker-view value={this.state.multiIndex} onChange={this.aliBindMultiPickerCol.bind(this)}>
                            <picker-view-column>
                                {this.state.interactionMultiArray.map((item, index) => {
                                    return <View key={index}>{item.name}</View>
                                })}
                            </picker-view-column>
                            <picker-view-column>
                                {this.state.interactionMultiArray[this.state.multiIndex[0]].children.map((item, index) => {
                                    return <View key={index}>{item.name}</View>
                                })}
                            </picker-view-column>

                        </picker-view>
                    </View ></View> : null}
            </View>


        )
    }
}

export default AliIndustryTypeInteraction

