import Taro, { Component } from '@tarojs/taro'
import { View, Image } from '@tarojs/components'
import URL from '../../../serviceAPI.config'


import './aliGoodCommentSection.scss'

//接收的参数 
// mainActived,subActived,productImagesUrl

class AliGoodCommentSection extends Component {
    config = {
        navigationBarTitleText: '商品详情和评论'
    }

    passMainCurrentToParent(value) {
        this.props.onAliMainOnClick(value)
    }
    passSubCurrentToParent(value) {
        this.props.onAliSubOnClick(value)
    }
    componentDidMount() {

    }
    componentWillReceiveProps(nextProps) {
        console.log(this.props, nextProps)
    }

    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }

    render() {
        const { mainActived, subActived, productImagesUrl } = this.props
        const mainTabList = [{ title: '宝贝详情' }, { title: '全部评价' }, { title: '猜你喜欢' }]
        const subTabList = [{ title: '全部' }, { title: '好评' }, { title: '中评' }, { title: '差评' }, { title: '公开' }, { title: '匿名' }]
        const tabArrayElement = mainTabList.map((item, index) => {
            return <View className={mainActived === index ? 'tab actived' : 'tab'} key={index} onClick={this.passMainCurrentToParent.bind(this, index)}>
                {item.title}
            </View>
        })
        const subTabArrayElement = subTabList.map((item, index) => {
            return <View className={subActived === index ? 'sub-tab sub-actived' : 'sub-tab'} key={index} onClick={this.passSubCurrentToParent.bind(this, index)}>
                {item.title}
            </View>
        })
        const itemDescriptionPicsElementArray = productImagesUrl.map((item, index) => {
            return <View className='description-img' key={index}>
                <Image mode='widthFix' src={URL.Base + item.file_path} style='width: 100%; max-height:100%;' />

            </View>
        })
        return (
            <View className='aliGoodCommentSection'>
                <View className='tab-wrapper'>
                    <View className='tabs'>
                        {tabArrayElement}
                    </View>
                    <View className='tab-details'>
                        {mainActived === 0 && <View className='first-tab' style='background-color: #FAFBFC;' >

                            <View className='description-title'>商品细节：</View>
                            <View className='description-img'>
                                {itemDescriptionPicsElementArray}

                            </View>

                        </View>
                        }
                        {mainActived === 1 && <View className='second-tab'>
                            <View className='tab-header'> {subTabArrayElement}</View>


                            {
                                subActived === 0 && <View className='sub-tab-details'>全部</View>
                            }
                            {
                                subActived === 1 && <View className='sub-tab-details'>好评</View>
                            }
                            {
                                subActived === 2 && <View className='sub-tab-details'>中评</View>
                            }
                            {
                                subActived === 3 && <View className='sub-tab-details'>差评</View>
                            }
                            {
                                subActived === 4 && <View className='sub-tab-details'>公开</View>
                            }
                            {
                                subActived === 5 && <View className='sub-tab-details'>匿名</View>
                            }




                        </View>}
                        {mainActived === 2 && <View className='third-tab' >标签页三的内容</View>}
                    </View>
                </View>

            </View>
        )
    }
}

export default AliGoodCommentSection
